/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ex02.c                                             :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: achubuko <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/11/30 19:58:12 by achubuko          #+#    #+#             */
/*   Updated: 2023/11/30 21:14:32 by achubuko         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */
#include <tests.h>
#define TESTS_RETURN_PRINTF "%p"

char *ft_strcat(char *dest, char *src);

int	main(void)
{
	TESTS_SEED(char);

	printf("initial strings:\n");
	dump(s, TEST_SOURCE_LENGHT);
	dump(d, TEST_DESTINATION_LENGHT);

	r1 = strcat(d1, s1);
	r2 = ft_strcat(d2, s2);
	TESTS_SYNOPSIS("strcat(d, s)");

	r1 = strcat(d1, s1);
	r2 = ft_strcat(d2, s2);
	TESTS_SYNOPSIS("strcat(d, s)");

	r1 = strcat(s1, d1);
	r2 = ft_strcat(s2, d2);
	TESTS_SYNOPSIS("strcat(s, d)");
}
